package edu.uncc.grid.example.workpool;

import java.io.IOException;

import net.jxta.pipe.PipeID;
import edu.uncc.grid.pgaf.Anchor;
import edu.uncc.grid.pgaf.Operand;
import edu.uncc.grid.pgaf.Seeds;
import edu.uncc.grid.pgaf.p2p.Types;

public class RunMatrixAddModule {
	
public static void main (String [] args ) { // 1st argument seeds location, 2nd argument host name

	try{

		long start = System.currentTimeMillis(); 

		Seeds.start( args[0] ,false); // starts framework and deploy on the list of servers

		MatrixAddModule  m = new MatrixAddModule();	     
	    m.initMatrices();
	     	
		PipeID id = Seeds.startPattern(new Operand ( (String[])null , new Anchor ( args[1] , Types.DataFlowRoll.SINK_SOURCE), m) ); 
	
		Seeds.waitOnPattern(id);

		Seeds.stop();
		
		m.printResult();
		
		long stop = System.currentTimeMillis();
		double time = (double) (stop - start);
		System.out.println("Execution time = " + time + " ms");

		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
