package edu.uncc.grid.example.workpool;

import java.io.IOException;

import net.jxta.pipe.PipeID;
import edu.uncc.grid.pgaf.Anchor;
import edu.uncc.grid.pgaf.Operand;
import edu.uncc.grid.pgaf.Seeds;
import edu.uncc.grid.pgaf.p2p.Types;

public class RunNumericalIntegration { // 1st argument host name

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			long start = System.currentTimeMillis();
			
			Seeds.start( args[0] , false);
			
			NumericalIntegrationModule mod = new NumericalIntegrationModule();
			
			PipeID id = Seeds.startPattern( new Operand( (String[])null, new Anchor( args[1]  , Types.DataFlowRoll.SINK_SOURCE), mod ) );
			
			Seeds.waitOnPattern(id);
			
			Seeds.stop();
			long stop = System.currentTimeMillis();
			
			System.out.println( "The area is: " + mod.getArea() ) ;	
			System.out.println("Execution time = " + (double) (stop - start) + " ms");
			
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
}
