package edu.uncc.grid.example.workpool;

import java.util.Random;
import java.util.logging.Level;

import edu.uncc.grid.pgaf.datamodules.Data;
import edu.uncc.grid.pgaf.datamodules.DataMap;
import edu.uncc.grid.pgaf.interfaces.basic.Workpool;
import edu.uncc.grid.pgaf.p2p.Node;

public class TemplateModule extends Workpool {

	private static final long serialVersionUID = 1L;

	// private fields
	int inputdata = 1;
	int results;
	int tasks = 9;  			// number of slave tasks

	public TemplateModule() {	  			
		// constructor		

	}
			
	public void initTemplate(){	  
		// Anything that needs a method to initialize
		
	}

	public int getDataCount() {  // Generally required to specify number of tasks

		return tasks;
	}

	public void initializeModule(String[] args) {
	
		Node.getLog().setLevel(Level.WARNING);

	}
	
	public Data DiffuseData(int segment) {

		DataMap<String, Object> d =new DataMap<String, Object > ();

		d.put("input",inputdata);
			
		return d;
	}

	public Data Compute(Data data) {
			
		DataMap<String, Object> input = (DataMap<String,Object>)data;
		DataMap<String, Object> output = new DataMap<String, Object>();
		
		// get data from master
		int x = (int) input.get("input");
		
		//computation
		int result = 2 * x; 						// just multiply it by 2 in this example

		// result to send out, given here as an integer
		output.put("out",result);	
		
		return output;
	}
	
	public void GatherData(int segment, Data dat) {

		DataMap<String,Object> out = (DataMap<String,Object>) dat;
		
		// get computed values from slaves
		int x = (int) out.get("out");
		
		// agregate each value and store in private field	
		results += x; 		 // here just added together, note this is done for each slave data

	}
	
	public void printResult(){
		System.out.println("Seeds template code, each slave simply multiples each input data by 2");
		System.out.println("Input data = " + inputdata);
		System.out.println("Number of slaves tasks = " + tasks);
		System.out.println("The results, summation of slave output data = " + results);			
	}

}       // end of TemplateModule

